Loading...
Searching...
No Matches
wayland::zwp_text_input_v3_t Class Reference

text input More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zwp_text_input_v3_t:
[legend]
Collaboration diagram for wayland::zwp_text_input_v3_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | enable ()
| Request text input to be enabled.
void | disable ()
| Disable text input on a surface.
void | set_surrounding_text (std::string const &text, int32_t cursor, int32_t anchor)
| sets the surrounding text
void | set_text_change_cause (zwp_text_input_v3_change_cause const &cause)
| indicates the cause of surrounding text change
void | set_content_type (zwp_text_input_v3_content_hint const &hint, zwp_text_input_v3_content_purpose const &purpose)
| set content purpose and hint
void | set_cursor_rectangle (int32_t x, int32_t y, int32_t width, int32_t height)
| set cursor position
void | commit ()
| commit state
std::function< void(surface_t)> & | on_enter ()
| enter event
std::function< void(surface_t)> & | on_leave ()
| leave event
std::function< void(std::string, int32_t, int32_t)> & | on_preedit_string ()
| pre-edit
std::function< void(std::string)> & | on_commit_string ()
| text commit
std::function< void(uint32_t, uint32_t)> & | on_delete_surrounding_text ()
| delete surrounding text
std::function< void(uint32_t)> & | on_done ()
| apply changes
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | enable_since_version = 1
| Minimum protocol version required for the enable function.
static constexpr std::uint32_t | disable_since_version = 1
| Minimum protocol version required for the disable function.
static constexpr std::uint32_t | set_surrounding_text_since_version = 1
| Minimum protocol version required for the set_surrounding_text function.
static constexpr std::uint32_t | set_text_change_cause_since_version = 1
| Minimum protocol version required for the set_text_change_cause function.
static constexpr std::uint32_t | set_content_type_since_version = 1
| Minimum protocol version required for the set_content_type function.
static constexpr std::uint32_t | set_cursor_rectangle_since_version = 1
| Minimum protocol version required for the set_cursor_rectangle function.
static constexpr std::uint32_t | commit_since_version = 1
| Minimum protocol version required for the commit function.

## Detailed Description

text input

The zwp_text_input_v3 interface represents text input and input methods associated with a seat. It provides enter/leave events to follow the text input focus for a seat.

Requests are used to enable/disable the text-input object and set state information like surrounding and selected text or the content type. The information about the entered text is sent to the text-input object via the preedit_string and commit_string events.

Text is valid UTF-8 encoded, indices and lengths are in bytes. Indices must not point to middle bytes inside a code point: they must either point to the first byte of a code point or to the end of the buffer. Lengths must be measured between two valid indices.

Focus moving throughout surfaces will result in the emission of zwp_text_input_v3.enter and zwp_text_input_v3.leave events. The focused surface must commit zwp_text_input_v3.enable and zwp_text_input_v3.disable requests as the keyboard focus moves across editable and non-editable elements of the UI. Those two requests are not expected to be paired with each other, the compositor must be able to handle consecutive series of the same request.

State is sent by the state requests (set_surrounding_text, set_content_type and set_cursor_rectangle) and a commit request. After an enter event or disable request all state information is invalidated and needs to be resent by the client.

Definition at line 6165 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## commit()

void zwp_text_input_v3_t::commit | ( |  | ) |

commit state

Atomically applies state changes recently sent to the compositor.

The commit request establishes and updates the state of the client, and must be issued after any changes to apply them.

Text input state (enabled status, content purpose, content hint, surrounding text and change cause, cursor rectangle) is conceptually double-buffered within the context of a text input, i.e. between a committed enable request and the following committed enable or disable request.

Protocol requests modify the pending state, as opposed to the current state in use by the input method. A commit request atomically applies all pending state, replacing the current state. After commit, the new pending state is as documented for each related request.

Requests are applied in the order of arrival.

Neither current nor pending state are modified unless noted otherwise.

The compositor must count the number of commit requests coming from each zwp_text_input_v3 object and use the count as the serial in done events.

Definition at line 8480 of file wayland-client-protocol-unstable.cpp.

## disable()

void zwp_text_input_v3_t::disable | ( |  | ) |

Disable text input on a surface.

Explicitly disable text input on the current surface (typically when there is no focus on any text entry inside the surface).

State set with this request is double-buffered. It will get applied on the next zwp_text_input_v3.commit request.

Definition at line 8450 of file wayland-client-protocol-unstable.cpp.

## enable()

void zwp_text_input_v3_t::enable | ( |  | ) |

Request text input to be enabled.

Requests text input on the surface previously obtained from the enter event.

This request must be issued every time the active text input changes to a new one, including within the current surface. Use zwp_text_input_v3.disable when there is no longer any input focus on the current surface.

Clients must not enable more than one text input on the single seat and should disable the current text input before enabling the new one. At most one instance of text input may be in enabled state per instance, Requests to enable the another text input when some text input is active must be ignored by compositor.

This request resets all state associated with previous enable, disable, set_surrounding_text, set_text_change_cause, set_content_type, and set_cursor_rectangle requests, as well as the state associated with preedit_string, commit_string, and delete_surrounding_text events.

The set_surrounding_text, set_content_type and set_cursor_rectangle requests must follow if the text input supports the necessary functionality.

State set with this request is double-buffered. It will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The changes must be applied by the compositor after issuing a zwp_text_input_v3.commit request.

Definition at line 8444 of file wayland-client-protocol-unstable.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

## on_commit_string()

std::function< void(std::string)> & zwp_text_input_v3_t::on_commit_string | ( |  | ) |

text commit

Parameters

  text |

Notify when text should be inserted into the editor widget. The text to commit could be either just a single character after a key press or the result of some composing (pre-edit).

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial value of text is an empty string.

Definition at line 8501 of file wayland-client-protocol-unstable.cpp.

## on_delete_surrounding_text()

std::function< void(uint32_t, uint32_t)> & zwp_text_input_v3_t::on_delete_surrounding_text | ( |  | ) |

delete surrounding text

Parameters

  before_length | length of text before current cursor position
  after_length | length of text after current cursor position

Notify when the text around the current cursor position should be deleted.

Before_length and after_length are the number of bytes before and after the current cursor index (excluding the selection) to delete.

If a preedit text is present, in effect before_length is counted from the beginning of it, and after_length from its end (see done event sequence).

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial values of both before_length and after_length are 0.

Definition at line 8506 of file wayland-client-protocol-unstable.cpp.

## on_done()

std::function< void(uint32_t)> & zwp_text_input_v3_t::on_done | ( |  | ) |

apply changes

Parameters

  serial |

Instruct the application to apply changes to state requested by the preedit_string, commit_string and delete_surrounding_text events. The state relating to these events is double-buffered, and each one modifies the pending state. This event replaces the current state with the pending state.

The application must proceed by evaluating the changes in the following order:

1. Replace existing preedit string with the cursor.
2. Delete requested surrounding text.
3. Insert commit string with the cursor at its end.
4. Calculate surrounding text to send.
5. Insert new preedit text in cursor position.
6. Place cursor inside preedit text.

The serial number reflects the last state of the zwp_text_input_v3 object known to the compositor. The value of the serial argument must be equal to the number of commit requests already issued on that object. When the client receives a done event with a serial different than the number of past commit requests, it must proceed as normal, except it should not change the current state of the zwp_text_input_v3 object.

Definition at line 8511 of file wayland-client-protocol-unstable.cpp.

## on_enter()

std::function< void(surface_t)> & zwp_text_input_v3_t::on_enter | ( |  | ) |

enter event

Parameters

  surface |

Notification that this seat's text-input focus is on a certain surface.

If client has created multiple text input objects, compositor must send this event to all of them.

When the seat has the keyboard capability the text-input focus follows the keyboard focus. This event sets the current surface for the text-input object.

Definition at line 8486 of file wayland-client-protocol-unstable.cpp.

## on_leave()

std::function< void(surface_t)> & zwp_text_input_v3_t::on_leave | ( |  | ) |

leave event

Parameters

  surface |

Notification that this seat's text-input focus is no longer on a certain surface. The client should reset any preedit string previously set.

The leave notification clears the current surface. It is sent before the enter notification for the new focus. After leave event, compositor must ignore requests from any text input instances until next enter event.

When the seat has the keyboard capability the text-input focus follows the keyboard focus.

Definition at line 8491 of file wayland-client-protocol-unstable.cpp.

## on_preedit_string()

std::function< void(std::string, int32_t, int32_t)> & zwp_text_input_v3_t::on_preedit_string | ( |  | ) |

pre-edit

Parameters

  text |
  cursor_begin |
  cursor_end |

Notify when a new composing text (pre-edit) should be set at the current cursor position. Any previously set composing text must be removed. Any previously existing selected text must be removed.

The argument text contains the pre-edit string buffer.

The parameters cursor_begin and cursor_end are counted in bytes relative to the beginning of the submitted text buffer. Cursor should be hidden when both are equal to -1.

They could be represented by the client as a line if both values are the same, or as a text highlight otherwise.

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial value of text is an empty string, and cursor_begin, cursor_end and cursor_hidden are all 0.

Definition at line 8496 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_content_type()

void zwp_text_input_v3_t::set_content_type | ( | zwp_text_input_v3_content_hint const & | hint,
|  | zwp_text_input_v3_content_purpose const & | purpose )

set content purpose and hint

Parameters

  hint |
  purpose |

Sets the content purpose and content hint. While the purpose is the basic purpose of an input field, the hint flags allow to modify some of the behavior.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request. Subsequent attempts to update them may have no effect. The values remain valid until the next committed enable or disable request.

The initial value for hint is none, and the initial value for purpose is normal.

Definition at line 8468 of file wayland-client-protocol-unstable.cpp.

## set_cursor_rectangle()

void zwp_text_input_v3_t::set_cursor_rectangle | ( | int32_t | x,
|  | int32_t | y,
|  | int32_t | width,
|  | int32_t | height )

set cursor position

Parameters

  x |
  y |
  width |
  height |

Marks an area around the cursor as a x, y, width, height rectangle in surface local coordinates.

Allows the compositor to put a window with word suggestions near the cursor, without obstructing the text being input.

If the client is unaware of the position of edited text, it should not issue this request, to signify lack of support to the compositor.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The initial values describing a cursor rectangle are empty. That means the text input does not support describing the cursor area. If the empty values get applied, subsequent attempts to change them may have no effect.

Definition at line 8474 of file wayland-client-protocol-unstable.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## set_surrounding_text()

void zwp_text_input_v3_t::set_surrounding_text | ( | std::string const & | text,
|  | int32_t | cursor,
|  | int32_t | anchor )

sets the surrounding text

Parameters

  text |
  cursor |
  anchor |

Sets the surrounding plain text around the input, excluding the preedit text.

The client should notify the compositor of any changes in any of the values carried with this request, including changes caused by handling incoming text-input events as well as changes caused by other mechanisms like keyboard typing.

If the client is unaware of the text around the cursor, it should not issue this request, to signify lack of support to the compositor.

Text is UTF-8 encoded, and should include the cursor position, the complete selection and additional characters before and after them. There is a maximum length of wayland messages, so text can not be longer than 4000 bytes.

Cursor is the byte offset of the cursor within text buffer.

Anchor is the byte offset of the selection anchor within text buffer. If there is no selected text, anchor is the same as cursor.

If any preedit text is present, it is replaced with a cursor for the purpose of this event.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The initial state for affected fields is empty, meaning that the text input does not support sending surrounding text. If the empty values get applied, subsequent attempts to change them may have no effect.

Definition at line 8456 of file wayland-client-protocol-unstable.cpp.

## set_text_change_cause()

void zwp_text_input_v3_t::set_text_change_cause | ( | zwp_text_input_v3_change_cause const & | cause | ) |

indicates the cause of surrounding text change

Parameters

  cause |

Tells the compositor why the text surrounding the cursor changed.

Whenever the client detects an external change in text, cursor, or anchor posision, it must issue this request to the compositor. This request is intended to give the input method a chance to update the preedit text in an appropriate way, e.g. by removing it when the user starts typing with a keyboard.

cause describes the source of the change.

The value set with this request is double-buffered. It must be applied and reset to initial at the next zwp_text_input_v3.commit request.

The initial value of cause is input_method.

Definition at line 8462 of file wayland-client-protocol-unstable.cpp.

## Member Data Documentation

## commit_since_version

std::uint32_t wayland::zwp_text_input_v3_t::commit_since_version = 1

static constexpr

Minimum protocol version required for the commit function.

Definition at line 6401 of file wayland-client-protocol-unstable.hpp.

## disable_since_version

std::uint32_t wayland::zwp_text_input_v3_t::disable_since_version = 1

static constexpr

Minimum protocol version required for the disable function.

Definition at line 6245 of file wayland-client-protocol-unstable.hpp.

## enable_since_version

std::uint32_t wayland::zwp_text_input_v3_t::enable_since_version = 1

static constexpr

Minimum protocol version required for the enable function.

Definition at line 6230 of file wayland-client-protocol-unstable.hpp.

## set_content_type_since_version

std::uint32_t wayland::zwp_text_input_v3_t::set_content_type_since_version = 1

static constexpr

Minimum protocol version required for the set_content_type function.

Definition at line 6337 of file wayland-client-protocol-unstable.hpp.

## set_cursor_rectangle_since_version

std::uint32_t wayland::zwp_text_input_v3_t::set_cursor_rectangle_since_version = 1

static constexpr

Minimum protocol version required for the set_cursor_rectangle function.

Definition at line 6368 of file wayland-client-protocol-unstable.hpp.

## set_surrounding_text_since_version

std::uint32_t wayland::zwp_text_input_v3_t::set_surrounding_text_since_version = 1

static constexpr

Minimum protocol version required for the set_surrounding_text function.

Definition at line 6289 of file wayland-client-protocol-unstable.hpp.

## set_text_change_cause_since_version

std::uint32_t wayland::zwp_text_input_v3_t::set_text_change_cause_since_version = 1

static constexpr

Minimum protocol version required for the set_text_change_cause function.

Definition at line 6314 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp